using System.Linq;
using System.Web.Mvc;

namespace MileageTraker.Web.Attributes
{
	public class ActionLogAttribute : ActionFilterAttribute
	{
		public override void OnActionExecuting(ActionExecutingContext filterContext)
		{
			if (filterContext != null)
			{
				var controller = filterContext.RouteData.Values["controller"].ToString();
				var action = filterContext.RouteData.Values["action"].ToString();
				var username = filterContext.HttpContext.User.Identity.Name;
				var loggerName = string.Format("{0}Controller.{1}", controller, action);
				var @params = string.Join(", ", filterContext.ActionParameters.Select(i => i.Key + ": " + i.Value));

				var hostAddress = "UserHostAddress: " + filterContext.HttpContext.Request.UserHostAddress;

				log4net.LogManager.GetLogger(loggerName)
					.InfoFormat("{0}, username: {1}, {2}", hostAddress, username, @params);
			}
			base.OnActionExecuting(filterContext);
		}
	}
}